APIRequestContext
This API is used for the Web API testing. You can use it to trigger API endpoints, configure micro-services, prepare environment or the service to your e2e test.
Each Playwright browser context has an associated APIRequestContext, accessible via browserContext.request or page.request (these return the
same instance — page.request is a shortcut for page.context().request). You can also create a standalone, isolated instance with apiRequest.newContext().
Cookie management
The APIRequestContext returned by browserContext.request and
page.request uses the same cookie jar as its BrowserContext:
If you want API requests that do not share cookies with the browser, create an isolated context via apiRequest.newContext(). Such APIRequestContext object will have its own isolated cookie storage.
Methods
delete
Added in: v1.16Sends HTTP(S) DELETE request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
await apiRequestContext.delete(url);
await apiRequestContext.delete(url, options);
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional) Added in: v1.17#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional) Added in: v1.17#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional) Added in: v1.17#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
dispose
Added in: v1.16All responses returned by apiRequestContext.get() and similar methods are stored in the memory, so that you can later call apiResponse.body().This method discards all its resources, calling any method on disposed APIRequestContext will throw an exception.
Usage
await apiRequestContext.dispose();
await apiRequestContext.dispose(options);
Arguments
optionsObject (optional)
Returns
fetch
Added in: v1.16Sends HTTP(S) request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
JSON objects can be passed directly to the request:
await request.fetch('https://example.com/api/createBook', {
method: 'post',
data: {
title: 'Book Title',
author: 'John Doe',
}
});
The common way to send file(s) in the body of a request is to upload them as form fields with multipart/form-data encoding, by specifiying the multipart parameter:
const form = new FormData();
form.set('name', 'John');
form.append('name', 'Doe');
// Send two file fields with the same name.
form.append('file', new File(['console.log(2024);'], 'f1.js', { type: 'text/javascript' }));
form.append('file', new File(['hello'], 'f2.txt', { type: 'text/plain' }));
await request.fetch('https://example.com/api/uploadForm', {
multipart: form
});
Arguments
-
urlOrRequeststring | Request#Target URL or Request to get all parameters from.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional)#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional)#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
If set changes the fetch method (e.g. PUT or POST). If not specified, GET method is used.
-
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional)#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
get
Added in: v1.16Sends HTTP(S) GET request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
Request parameters can be configured with params option, they will be serialized into the URL search parameters:
// Passing params as object
await request.get('https://example.com/api/getText', {
params: {
'isbn': '1234',
'page': 23,
}
});
// Passing params as URLSearchParams
const searchParams = new URLSearchParams();
searchParams.set('isbn', '1234');
searchParams.append('page', 23);
searchParams.append('page', 24);
await request.get('https://example.com/api/getText', { params: searchParams });
// Passing params as string
const queryString = 'isbn=1234&page=23&page=24';
await request.get('https://example.com/api/getText', { params: queryString });
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional) Added in: v1.26#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional) Added in: v1.26#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional) Added in: v1.26#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
head
Added in: v1.16Sends HTTP(S) HEAD request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
await apiRequestContext.head(url);
await apiRequestContext.head(url, options);
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional) Added in: v1.26#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional) Added in: v1.26#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional) Added in: v1.26#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
patch
Added in: v1.16Sends HTTP(S) PATCH request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
await apiRequestContext.patch(url);
await apiRequestContext.patch(url, options);
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional)#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional)#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional)#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
post
Added in: v1.16Sends HTTP(S) POST request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
JSON objects can be passed directly to the request:
await request.post('https://example.com/api/createBook', {
data: {
title: 'Book Title',
author: 'John Doe',
}
});
To send form data to the server use form option. Its value will be encoded into the request body with application/x-www-form-urlencoded encoding (see below how to use multipart/form-data form encoding to send files):
await request.post('https://example.com/api/findBook', {
form: {
title: 'Book Title',
author: 'John Doe',
}
});
The common way to send file(s) in the body of a request is to upload them as form fields with multipart/form-data encoding. Use FormData to construct request body and pass it to the request as multipart parameter:
const form = new FormData();
form.set('name', 'John');
form.append('name', 'Doe');
// Send two file fields with the same name.
form.append('file', new File(['console.log(2024);'], 'f1.js', { type: 'text/javascript' }));
form.append('file', new File(['hello'], 'f2.txt', { type: 'text/plain' }));
await request.post('https://example.com/api/uploadForm', {
multipart: form
});
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional)#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional)#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional)#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
put
Added in: v1.16Sends HTTP(S) PUT request and returns its response. The method will populate request cookies from the context and update context cookies from the response. The method will automatically follow redirects.
Usage
await apiRequestContext.put(url);
await apiRequestContext.put(url, options);
Arguments
-
Target URL.
-
optionsObject (optional)-
datastring | Buffer | Serializable (optional)#Allows to set post data of the request. If the data parameter is an object, it will be serialized to json string and
content-typeheader will be set toapplication/jsonif not explicitly set. Otherwise thecontent-typeheader will be set toapplication/octet-streamif not explicitly set. -
failOnStatusCodeboolean (optional)#Whether to throw on response codes other than 2xx and 3xx. By default response object is returned for all status codes.
-
formObject<string, string | number | boolean> | FormData (optional)#Provides an object that will be serialized as html form using
application/x-www-form-urlencodedencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set toapplication/x-www-form-urlencodedunless explicitly provided. -
headersObject<string, string> (optional)#Allows to set HTTP headers. These headers will apply to the fetched request as well as any redirects initiated by it.
-
ignoreHTTPSErrorsboolean (optional)#Whether to ignore HTTPS errors when sending network requests. Defaults to
false. -
maxRedirectsnumber (optional) Added in: v1.26#Maximum number of request redirects that will be followed automatically. An error will be thrown if the number is exceeded. Defaults to
20. Pass0to not follow redirects. -
maxRetriesnumber (optional) Added in: v1.46#Maximum number of times network errors should be retried. Currently only
ECONNRESETerror is retried. Does not retry based on HTTP response codes. An error will be thrown if the limit is exceeded. Defaults to0- no retries. -
multipartFormData | Object<string, string | number | boolean | ReadStream | Object> (optional)#Provides an object that will be serialized as html form using
multipart/form-dataencoding and sent as this request body. If this parameter is specifiedcontent-typeheader will be set tomultipart/form-dataunless explicitly provided. File values can be passed either asfs.ReadStreamor as file-like object containing file name, mime-type and its content. -
paramsObject<string, string | number | boolean> | URLSearchParams | string (optional)#Query parameters to be sent with the URL.
-
Request timeout in milliseconds. Defaults to
30000(30 seconds). Pass0to disable timeout.
-
Returns
storageState
Added in: v1.16Returns storage state for this request context, contains current cookies and local storage snapshot if it was passed to the constructor.
Usage
await apiRequestContext.storageState();
await apiRequestContext.storageState(options);
Arguments
optionsObject (optional)-
indexedDBboolean (optional) Added in: v1.51#Set to
trueto include IndexedDB in the storage state snapshot. -
The file path to save the storage state to. If path is a relative path, then it is resolved relative to current working directory. If no path is provided, storage state is still returned, but won't be saved to the disk.
-
Returns
Properties
tracing
Added in: v1.60Usage
apiRequestContext.tracing
Type